<template>
  <v-container fill-height>
    <v-app-bar
      app
      dense
      fixed
      dark
      color="indigo darken-4"
      class="grady-toolbar"
    >
      <router-link to="/home">
        <v-app-bar-title>Grady</v-app-bar-title>
      </router-link>
      <span class="pl-2 grady-speak">{{ gradySpeak }}</span>
      <v-spacer />
      <v-divider vertical />
      <user-options />
    </v-app-bar>
    <v-layout
      align-center
      justify-center
    >
      <v-card
        class="mx-auto"
        max-width="600"
        min-width="500"
      >
        <v-card-title>
          <h1>Select Exam<br></h1>
        </v-card-title>
        <v-card-text>
          <p style="color:grey;">
            You can always come back and change your selection
          </p>
        </v-card-text>
        <v-list>
          <v-list-item
            v-for="examType in examTypes"
            id="listItem"
            :key="examType.pk"
            @click="selectExamType(examType)"
          >
            {{ examType.moduleReference }}
          </v-list-item>
        </v-list>
      </v-card>
    </v-layout>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import RegisterDialog from '@/components/RegisterDialog'
import { Authentication as Auth } from '@/store/modules/authentication'
import { ConfigModule } from '../store/modules/config'
import store from '@/store/store'
import { getters } from '@/store/getters'
import { actions } from '@/store/actions'
import ax, { fetchExamTypes } from '@/api'
import { Config } from '@/models'
import UserOptions from '@/components/UserOptions'


export default {
  name: 'ExamSelection',
  components: { UserOptions },
  data () {
    return {
      examTypes: [],
    }
  },
  computed: {
    msg () { return Auth.state.message },
    userRole () { return Auth.state.user.role },
    gradySpeak () { return Auth.gradySpeak },
  },
  created () {
    this.loadExamTypes()
  },
  methods: {
    selectExamType (examType) {
      ConfigModule.SET_CURRENT_EXAM(examType.moduleReference)
      ConfigModule.SET_CURRENT_EXAM_ID(examType.pk)
      this.$router.push({ name: 'home' })
    },
    logout () {
      actions.logout()
    },
    async loadExamTypes () {
      try {
        const response = (await ax.get('/api/examtype/')).data
        this.examTypes = response
        if (this.examTypes.length === 0) {
          this.$router.push({ name: 'home' })
        }
        else if (this.examTypes.length === 1) {
          this.selectExamType(this.examTypes[0])
        }
      } catch (ex) {
        console.log(ex)
      }
    },
  }
}
</script>

<style scoped>
  .v-btn {
    margin: 0px;
  }

  .btn-container {
    display: flex;
    flex-wrap: nowrap;
    justify-content: space-around;
  }

  .grady-toolbar {
    font-weight: bold;
  }
</style>
